## Running CNN benchmarks

NOTE: Before running the CNN benchmarks on NVIDIA Jetson TX2, the following script must be executed in order to ensure that the clocks are running at the maximum frequency:
```
bash jetson_clocks.sh
```

We provide two scripts to run the CNN benchmarks automatically: run_dnn.py and run_dnns.py. 

In order to run all CNN benchmarks, execute the following:
```
python run_dnns.py
```

And to run a particular benchmark, one must specify the name of the benchmark. The valid names of the benchmarks are: alexnet_cifar10, alexnet2_cifar10, alexnet_imagenet, lenet_mnist, mobilenet_cifar10, resnet18_cifar10, resnet50_imagenet, vgg16_cifar10, vgg16_cifar100 and vgg16_imagenet.
```
python run_dnn.py <dnn_name>
```
 
These scripts not only automate the execution of the benchmarks, but also produce trade-off curves between accuracy and performance for executed benchmarks. These trade-off curves are named as <dnn_name>-tradeoff-curves.txt under ./hpvm/hpvm/docs/tradeoff-curves. Trade-off curves for the CNN benchmarks suit are already provided as examples under ./hpvm/hpvm/docs/tradeoff-curves.
